<script lang="ts">
	interface Props {
		title: string;
		description: string;
		link: string;
		href: string;
		style: string;
		postValue: any;
		children?: import('svelte').Snippet;
	}

	let {
		title,
		description,
		link,
		href,
		style,
		postValue,
		children
	}: Props = $props();
</script>

<div class="card" {style}>
	{@render children?.()}
	<span class="title">{title}</span>
	<p class="description">{description}</p>
	<form method="POST" action={href}>
		<button class="link" name="card" value={postValue}><span class="link_content">{link}</span></button>
	</form>
</div>

<style>
	.card {
		display: inline-flex;
		flex-direction: row;
		background-color: #1e1e1e;
		color: #ffffff;
		display: block;
		max-width: 100%;
		outline: none;
		text-decoration: none;
		transition-property: box-shadow, opacity;
		overflow-wrap: break-word;
		position: relative;
		white-space: normal;
		padding-left: 2rem;
		padding-right: 2rem;
		padding-top: 1rem;
		padding-bottom: 1rem;
	}

	.title {
		align-items: center;
		display: flex;
		flex-wrap: wrap;
		font-size: 1.25rem;
		font-weight: 500;
		letter-spacing: 0.0125em;
		line-height: 2rem;
		word-break: break-all;
		padding: 16px;
	}

	.description {
		color: #ffffffbb;
		font-size: 0.875rem;
		font-weight: 400;
		line-height: 1.375rem;
		letter-spacing: 0.0071428571em;
		padding: 16px;
		text-align: left;
	}

	.link {
		align-items: center;
		border-radius: 4px;
		display: inline-flex;
		flex: 0 0 auto;
		overflow: hidden;
		position: relative;
		outline: 0;
		justify-content: center;
		user-select: none;
		vertical-align: middle;
		white-space: nowrap;
		text-decoration: none;
		transition-duration: 0.28s;
		transition-property: box-shadow, transform, opacity;
		padding: 1rem;
		background-color: transparent;
		border: none;
		font-size: 0.9rem;
	}

	.link .link_content {
		font-weight: 500;
		letter-spacing: 0.1rem;
		text-transform: uppercase;
		color: var(--accentColour);
	}

	.link:hover {
		opacity: 0.8;
	}
</style>
